<template>
  <div class="home">
    <img src="@/assets/img/logo.jpg" alt="">
    <h1>Projet Gones Live</h1>
    <section class="project-title">
      <input type="text" v-model="projectTitle" placeholder="Titre du projet"/>
      <textarea name="" v-model="projectDescription" id="" cols="30" rows="10" placeholder="Description" />
      <input v-model="userMail" type="email" placeholder="Adresse email">
      <input type="text" v-model="userName" placeholder="Auteur">
    </section>
    <section class="project-questions">
      <project-question v-for="(question, index) in questions" :key="index" @removeQuestion="removeQuestion" :question="question" :index="index"/>
      <p @click="addQuestion" class="add-question">➕ Ajouter une question</p>
    </section>
    <section class="validate">
      <button @click="submitProject" :class="{ inactive: !isProjectValid}">Valider le projet</button>
    </section>
  </div>
</template>

<script>

import ProjectQuestion from '@/components/ProjectQuestion'
import axios from 'axios'
import { mapGetters } from 'vuex'

export default {
  name: 'CreateProject',
  components: { ProjectQuestion },
  data: () => {
    return {
      projectTitle: '',
      projectDescription: '',
      userMail: '',
      userName: '',
      questions: [{
        title: '',
        num_question: 0,
        responses: [{
          num_response: 0,
          response: '',
          scene: ''
        }]
      }]
    }
  },
  computed: {
    // map `this.user` to `this.$store.getters.user`
    ...mapGetters({
      user: 'user'
    }),
    isProjectValid: function () {
      return this.projectTitle.title !== '' && this.projectDescription !== '' && this.userMail !== '' && this.userName !== '' && this.questions && this.questions.length > 1 && !this.emptyQuestionTitles && !this.emptyResponsesField
    },
    emptyQuestionTitles: function () {
      const emptyQuestionsTitles = this.questions.find(e => {
        return e.title === ''
      })
      return !!emptyQuestionsTitles
    },
    emptyResponsesField: function () {
      const emptyTitles = []
      this.questions.forEach(question => {
        const emptyResponse = question.responses.find(e => {
          return e.response === '' || e.scene === ''
        })
        if (emptyResponse) {
          emptyTitles.push(emptyResponse)
        }
      })
      return emptyTitles.length !== 0
    }
  },
  created () {
    // if user is not auth, redirect to home page
    if (!this.user.data) {
      this.$router.push('/')
    }
  },
  methods: {
    addQuestion: function () {
      const questionModel = {
        title: '',
        num_question: this.questions.length,
        responses: [{
          num_response: 0,
          response: '',
          scene: ''
        }]
      }
      this.questions.push(questionModel)
    },
    removeQuestion: function (index) {
      this.questions.splice(index, 1)
    },
    submitProject: function () {
      if (this.isProjectValid) {
        const url = 'https://api.goneslive.fr/projects'
        const body = {
          title: this.projectTitle,
          description: this.projectDescription,
          email: this.userMail,
          author: this.userName,
          questions: this.questions
        }
        axios({
          method: 'post',
          url: url,
          data: body
        }).then(r => {
          console.log(r)
        }).catch(e => {
          console.log(e.response)
        })
      }
    }
  }
}
</script>

<style lang="scss">
.home {
  box-sizing: border-box;
  width: 100%;
  padding: 2em;
  max-width: 780px;
  margin: 1em auto;
  img {
    max-width: 200px;
  }
  .project-title {
    box-sizing: border-box;
    width: 100%;
    input {
      box-sizing: border-box;
      font-size: 2em;
      width: 100%;
      text-align: center;
      border-radius: 6px;
      border: 1px solid #535353;
      padding: .2em 1em;
    }
  }
  .project-questions {
    margin: 3em 0;
    .add-question {
      cursor: pointer;
    }
  }
  .validate {
    button {
      background: #44c83b;
      color: white;
      border-radius: 6px;
      border: none;
      transition: transform .5s;
      font-size: 1.2em;
      padding: .5em 1em;
      cursor: pointer;
      &:hover {
        transform: scale(1.1);
        transition: transform .5s;
      }
      &.inactive {
        background: #AAAAAA;
        cursor: not-allowed;
      }
    }
  }
}
</style>
